<?Php 
$watermarkImgFile = $argv[1];
$sourceImageFile = $argv[2];
$watermarkOpacity = $argv[3];
$chooseWatermarkLoc = $argv[4];

#$watermarkImgFile,$sourceImageFile,$watermarkOpacity,$chooseWatermarkLoc
if (exif_imagetype($watermarkImgFile) == IMAGETYPE_GIF) {
    $watermark = imagecreatefromgif($watermarkImgFile);
}else{
	if (exif_imagetype($watermarkImgFile) == IMAGETYPE_JPEG) {
		$watermark = imagecreatefromjpeg($watermarkImgFile);
	}else{
		if (exif_imagetype($watermarkImgFile) == IMAGETYPE_PNG) {
			$watermark = imagecreatefrompng($watermarkImgFile);
		}else{
			if (exif_imagetype($watermarkImgFile) == IMAGETYPE_PSD) {
				$watermark = imagecreatefrompsd($watermarkImgFile);
			}else{
				if (exif_imagetype($watermarkImgFile) == IMAGETYPE_BMP) {
					$watermark = imagecreatefromwbmp($watermarkImgFile);
				}
			}
		}
	}
}

  
$watermark_width = imagesx($watermark);  
$watermark_height = imagesy($watermark);  
$image = imagecreatetruecolor($watermark_width, $watermark_height);
if (exif_imagetype($sourceImageFile) == IMAGETYPE_GIF) {
    $image = imagecreatefromgif($sourceImageFile);
}else{
	if (exif_imagetype($sourceImageFile) == IMAGETYPE_JPEG) {
		$image = imagecreatefromjpeg($sourceImageFile);
	}else{
		if (exif_imagetype($sourceImageFile) == IMAGETYPE_PNG) {
			$image = imagecreatefrompng($sourceImageFile);
		}else{
			if (exif_imagetype($sourceImageFile) == IMAGETYPE_PSD) {
				$image = imagecreatefrompsd($sourceImageFile);
			}else{
				if (exif_imagetype($sourceImageFile) == IMAGETYPE_BMP) {
					$image = imagecreatefromwbmp($sourceImageFile);
				}
			}
		}
	}
}

$size = getimagesize($sourceImageFile);
#FIGURE OUT WHERE TO PLACE THE WATERMARK
if ($chooseWatermarkLoc == "topleft"){
	$dest_x = 5;  
	$dest_y = 5; 
}
if ($chooseWatermarkLoc == "topright"){
	$dest_x = $size[0] - $watermark_width - 5;  
	$dest_y = 5;
}
if ($chooseWatermarkLoc == "bottomright"){
	$dest_x = $size[0] - $watermark_width - 5;  
	$dest_y = $size[1] - $watermark_height - 5;
}
if ($chooseWatermarkLoc == "bottomleft"){
	$dest_x = 5;  
	$dest_y = $size[1] - $watermark_height - 5;
}
if ($chooseWatermarkLoc == "center"){
	$dest_x = ($size[0]/2) - ($watermark_width/2);  
	$dest_y = ($size[1]/2) - ($watermark_height/2);
}
#DO THE WORK
imagecopymerge_alpha($image, $watermark, $dest_x, $dest_y, 0, 0, $watermark_width, $watermark_height, $watermarkOpacity); 
#OLD
#imagecopymerge($image, $watermark, $dest_x, $dest_y, 0, 0, $watermark_width, $watermark_height, $watermarkOpacity);  
#SAVE AS JPEG
imagejpeg ($image, $sourceImageFile, 100);
#CLEAN UP
imagedestroy($image);  
imagedestroy($watermark);  


function imagecopymerge_alpha($dst_im, $src_im, $dst_x, $dst_y, $src_x, $src_y, $src_w, $src_h, $pct){ 
    if(!isset($pct)){ 
        return false; 
    } 
    $pct /= 100;
    // Get image width and height 
    $w = imagesx( $src_im ); 
    $h = imagesy( $src_im ); 
    // Turn alpha blending off 
    imagealphablending( $src_im, false ); 
    // Find the most opaque pixel in the image (the one with the smallest alpha value) 
    $minalpha = 127; 
    for( $x = 0; $x < $w; $x++ ) 
		for( $y = 0; $y < $h; $y++ ){ 
			$alpha = ( imagecolorat( $src_im, $x, $y ) >> 24 ) & 0xFF; 
			if( $alpha < $minalpha ){ 
				$minalpha = $alpha; 
			} 
		} 
    //loop through image pixels and modify alpha for each 
    for( $x = 0; $x < $w; $x++ ){ 
        for( $y = 0; $y < $h; $y++ ){ 
            //get current alpha value (represents the TANSPARENCY!) 
            $colorxy = imagecolorat( $src_im, $x, $y ); 
            $alpha = ( $colorxy >> 24 ) & 0xFF; 
            //calculate new alpha 
            if( $minalpha !== 127 ){ 
                $alpha = 127 + 127 * $pct * ( $alpha - 127 ) / ( 127 - $minalpha ); 
            } else { 
                $alpha += 127 * $pct; 
            } 
            //get the color index with new alpha 
            $alphacolorxy = imagecolorallocatealpha( $src_im, ( $colorxy >> 16 ) & 0xFF, ( $colorxy >> 8 ) & 0xFF, $colorxy & 0xFF, $alpha ); 
            //set pixel with the new color + opacity 
            if( !imagesetpixel( $src_im, $x, $y, $alphacolorxy ) ){ 
                return false; 
            } 
        } 
    } 
    // The image copy 
    imagecopy($dst_im, $src_im, $dst_x, $dst_y, $src_x, $src_y, $src_w, $src_h); 
} 

?>

